;-Verrechnung der ADC Rohwerte zu arithmetischen mitteln aus 16 werten, sowie zu werten mit einheit------------------------------
CalcADCValue:			push		r0
						push		r1
						push		r16
						in			r16,CPU_SREG
						push		r16
						push		r17
						push		r18
						push		r19
						push		r20
						push		r21
						push		r26
						push		r27
						push		r28
						push		r29
						push		r30
						push		r31

						ldi			r28,low(CVAR_SRAM_ADC_RAW_I_ENGINE_LOW)									; lade erste adresse der adc rohwerte in Y
						ldi			r29,high(CVAR_SRAM_ADC_RAW_I_ENGINE_LOW)								; "
						ldi			r30,low(CVAR_SRAM_ADC_AMM_I_ENGINE_LOW)									; lade erste adresse der mittelwert speicher in Z
						ldi			r31,high(CVAR_SRAM_ADC_AMM_I_ENGINE_LOW)								; "

CalcADCValue_AMM:		ld			r16,Y+																	; lade rohwert low in r16
						ld			r17,Y+																	; lade rohwert high in r17
						ld			r18,Z+																	; lade mittelwert speicher low in r18
						ld			r19,Z																	; lade mittelwert speicher high in r19

						subi		r16,low(CVAR_ADCA_Offset)												; offset abziehen
						sbci		r17,high(CVAR_ADCA_Offset)												; "
						brpl		CalcADCValue_ZER														; wenn negativer berlauf

						clr			r16																		; setze wert 0
						clr			r17																		; "

CalcADCValue_ZER:		add			r18,r16																	; addiere adc wert zu mittelwertspeicher
						adc			r19,r17																	; "

						sbiw		r30,1																	; setze Z um einen zurck

						st			Z+,r18																	; schreibe mittelwert speicher in ram
						st			Z+,r19																	; "

						cpi			r28,low(CVAR_SRAM_ADC_RAW_I_ENGINE_LOW + 24)							; solange nicht alle rohwerte verrechnet sind
						brne		CalcADCValue_AMM														; springe
						cpi			r29,high(CVAR_SRAM_ADC_RAW_I_ENGINE_LOW + 24)							; "
						brne		CalcADCValue_AMM														; "

						lds			r16,CVAR_SRAM_ADC_AMM_COUNT												; lade wert-zhler aus ram in r16

						inc			r16																		; erhhe wert-zhler um einen

						cpi			r16,16																	; solange nicht 16 werte aufgenommen wurden
						brlo		CalcADCValue_END														; springe

						clr			r16																		; lade nullen in r16
						ldi			r26,low(CVAR_SRAM_ADC_I_ENGINE_LOW)										; lade erste adresse der messwerte in X
						ldi			r27,high(CVAR_SRAM_ADC_I_ENGINE_LOW)									; "
						ldi			r28,low(CVAR_SRAM_ADC_AMM_I_ENGINE_LOW)									; lade erste adresse der mittelwert speicher in Y
						ldi			r29,high(CVAR_SRAM_ADC_AMM_I_ENGINE_LOW)								; "
						ldi			r30,low(ADCMultiplikatoren*2)											; lade die Startadresse der Multiplikatortabelle in Z
						ldi			r31,high(ADCMultiplikatoren*2)											; "	

CalcADCValue_CLC:		ld			r18,Y+																	; lade mittelwert speicher low in r18
						ld			r19,Y																	; lade mittelwert speicher high in r19

						sbiw		r28,1																	; setze Y um einen zurck

						st			Y+,r16																	; lsche mittelwert speicher
						st			Y+,r16																	; "

						lsr			r19																		; teile gespeicherten wert durch 16
						ror			r18																		; "
						lsr			r19																		; "
						ror			r18																		; "
						lsr			r19																		; "
						ror			r18																		; "
						lsr			r19																		; "
						ror			r18																		; "

						lpm			r20,Z+																	; lade multiplikator in r20
						lpm			r21,Z+																	; lade teiler in r21

						mul			r18,r20																	; multipliziere low byte

						mov			r16,r0																	; lade ergebnis low in r16
						mov			r17,r1																	; lade ergebnis high in r17

						mul			r19,r20																	; multipliziere high byte

						clr			r18																		; lade nullen in r18(low byte vor dem highbyte ergebnis)
						mov			r19,r0																	; lade ergebnis low in r19
						mov			r20,r1																	; lade ergebnis high in r20

						add			r18,r16																	; addiere low und high ergebnis
						adc			r19,r17																	; "
						clr			r16																		; "
						clr			r17																		; "
						adc			r20,r16																	; "

						cpi			r21,0																	; wenn divisor gleich null
						breq		CalcADCValue_STO														; berspringe teilerblock

CalcADCValue_DIV:		sub			r18,r21																	; subtrahiere teiler vom ergebnis
						sbci		r19,0																	; "
						sbci		r20,0																	; "
						brmi		CalcADCValue_STO														; wenn rest negativ ist, springe (keine weitere division mglich)

						clc																					; lsche carry
						inc			r16																		; erhhe divisionszhler low
						brcc		CalcADCValue_DIV														; wenn kein berlauf stattgefunden hat, springe
						inc			r17																		; erhhe divisionszhler high
						jmp			CalcADCValue_DIV														; springe

CalcADCValue_STO:		st			X+,r16																	; speichere errechneten messwert in ram
						st			X+,r17																	; "

						clr			r16																		; lade nullen in r16

						cpi			r28,low(CVAR_SRAM_ADC_AMM_I_ENGINE_LOW + 24)							; wenn nochnicht alle mittelwerte verrechnet wurden
						brne		CalcADCValue_CLC														; springe
						cpi			r29,high(CVAR_SRAM_ADC_AMM_I_ENGINE_LOW + 24)							; "
						brne		CalcADCValue_CLC														; "

CalcADCValue_END:		sts			CVAR_SRAM_ADC_AMM_COUNT,r16												; speichere wertzhler im ram

						pop			r31
						pop			r30
						pop			r29
						pop			r28
						pop			r27
						pop			r26
						pop			r21
						pop			r20
						pop			r19
						pop			r18
						pop			r17
						pop			r16
						out			CPU_SREG,r16
						pop			r16
						pop			r1
						pop			r0
						ret

;---------------------------------------------------------------------------------