;-erzeugt eine blinkfolge entsprechend den betriebszustnden gem ram---------------------------------
; ------Priorisierung--------
; 1. Dauer an:						Clock Instabil
; 2. 2x Aufblitzen, 2sek pause:		Submodul fehler
; 3. 3x Aufblitzen, 2sek pause:		WLAN Modul fehlt
; 4. 1x Aufblitzen, 4sek pause:		Power Down modus
; 5. 8Hz Blinken:					Programmiermodus
; 6. 4Hz Blinken:					StartUp
; 7. 1Hz Blinken:					Normal Operation
DoBlink:			push		r16
					in			r16,CPU_SREG
					push		r16
					push		r17

					lds			r16,CVAR_SRAM_MAIN_STATUS_1												; lade statusbyte 1 aus ram in r16
					lds			r17,CVAR_SRAM_MAIN_STATUS_2												; lade statusbyte 2 aus ram in r17

					sbrc		r17,2																	; wenn warfare flag gesetzt ist
					jmp			DoBlink_CLR																; springe
					sbrs		r17,0																	; wenn bugklappe geschlossen
					jmp			DoBlink_CLR																; springe

					sbrc		r16,0																	; wenn clock instable flag gesetzt ist
					jmp			DoBlink_CIF																; springe
					sbrc		r16,5																	; wenn submodul fehler flag gesetzt ist
					jmp			DoBlink_SFF																; springe
					sbrc		r16,1																	; wenn wlan modul fehlt flag gesetzt ist
					jmp			DoBlink_WMF																; springe
					sbrc		r17,4																	; wenn power down modus flag gesetzt ist
					jmp			DoBlink_PDM																; springe
					sbrc		r17,5																	; wenn programmiermodus flag gesetzt ist
					jmp			DoBlink_PRM																; springe
					sbrc		r16,2																	; wenn startup modus flag gesetzt ist
					jmp			DoBlink_SUP																; springe
					sbrc		r16,4																	; wenn normal operation flag gesetzt ist
					jmp			DoBlink_NOM																; springe
					
					clr			r16																		; resette stepcounter 1

					ldi			r17,0b00001000															; schalte prozess led aus
					sts			PORTB_OUTCLR,r17														; "

DoBlink_END:		sts			CVAR_SRAM_MAIN_BLINK_CNT1,r16											; schreibe stepcounter 1 in ram

DoBlink_END2:		pop			r17
					pop			r16
					out			CPU_SREG,r16
					pop			r16
					ret

;--------------------------------------------------------------------------------------------------------
DoBlink_CIF:		ldi			r17,0b00001000															; schalte prozes led an
					sts			PORTB_OUTSET,r17														; "

					ldi			r16,1																	; lade priorittszahl in r16
					sts			CVAR_SRAM_MAIN_BLINK_CNT2,r16											; speichere priorittszahl in stepcounter 2

					clr			r16																		; resette stepcounter 1

					jmp			DoBlink_END

;-------------------------------------------------------------------------------------------------------
DoBlink_SFF:		lds			r16,CVAR_SRAM_MAIN_BLINK_CNT1											; lade stepcounter 1 in r16

					lds			r17,CVAR_SRAM_MAIN_BLINK_CNT2											; lade stepcounter 2 in r17
					cpi			r17,2																	; vergleiche stepcounter mit priorittszahl
					breq		DoBlink_SFF_0															; springe, wenn identisch

					clr			r16																		; resette stepcounter 1

DoBlink_SFF_0:		ldi			r17,0b00001000															; lade bitmuster fr prozess led in r17
					
					cpi			r16,0																	; wenn stepcounter nicht null
					brne		DoBlink_SFF_1															; springe

					ldi			r16,2																	; lade priorittszahl in r16
					sts			CVAR_SRAM_MAIN_BLINK_CNT2,r16											; speichere priorittszahl in stepcounter 2

					ldi			r16,41																	; lade schrittzhler mit neuem startwert

DoBlink_SFF_1:		cpi			r16,39																	; wenn stepcounter unter 39
					brlo		DoBlink_SFF_2															; springe
					
					sts			PORTB_OUTSET,r17														; schalte prozes led ein

					jmp			DoBlink_SFF_END															; springe

DoBlink_SFF_2:		cpi			r16,36																	; wenn stepcounter unter 36
					brlo		DoBlink_SFF_3															; springe

					sts			PORTB_OUTCLR,r17														; schalte prozes led aus

					jmp			DoBlink_SFF_END															; springe

DoBlink_SFF_3:		cpi			r16,33																	; wenn stepcounter unter 33
					brlo		DoBlink_SFF_4															; springe

					sts			PORTB_OUTSET,r17														; schalte prozes led ein

					jmp			DoBlink_SFF_END															; springe

DoBlink_SFF_4:		sts			PORTB_OUTCLR,r17														; schalte prozes led aus

DoBlink_SFF_END:	dec			r16																		; stepcounter -1
					
					jmp			DoBlink_END

;-------------------------------------------------------------------------------------------------------
DoBlink_WMF:		lds			r16,CVAR_SRAM_MAIN_BLINK_CNT1											; lade stepcounter 1 in r16
					
					lds			r17,CVAR_SRAM_MAIN_BLINK_CNT2											; lade stepcounter 2 in r17
					cpi			r17,3																	; vergleiche stepcounter mit priorittszahl
					breq		DoBlink_WMF_0															; springe, wenn identisch

					clr			r16																		; resette stepcounter 1

DoBlink_WMF_0:		ldi			r17,0b00001000															; lade bitmuster fr prozess led in r17
					
					cpi			r16,0																	; wenn stepcounter nicht null
					brne		DoBlink_WMF_1															; springe

					ldi			r16,3																	; lade priorittszahl in r16
					sts			CVAR_SRAM_MAIN_BLINK_CNT2,r16											; speichere priorittszahl in stepcounter 2

					ldi			r16,47																	; lade schrittzhler mit neuem startwert

DoBlink_WMF_1:		cpi			r16,45																	; wenn stepcounter unter 45
					brlo		DoBlink_WMF_2															; springe
					
					sts			PORTB_OUTSET,r17														; schalte prozes led ein

					jmp			DoBlink_WMF_END															; springe

DoBlink_WMF_2:		cpi			r16,42																	; wenn stepcounter unter 42
					brlo		DoBlink_WMF_3															; springe

					sts			PORTB_OUTCLR,r17														; schalte prozes led aus

					jmp			DoBlink_WMF_END															; springe

DoBlink_WMF_3:		cpi			r16,39																	; wenn stepcounter unter 39
					brlo		DoBlink_WMF_4															; springe

					sts			PORTB_OUTSET,r17														; schalte prozes led ein

					jmp			DoBlink_WMF_END															; springe

DoBlink_WMF_4:		cpi			r16,36																	; wenn stepcounter unter 36
					brlo		DoBlink_WMF_5															; springe

					sts			PORTB_OUTCLR,r17														; schalte prozes led aus

					jmp			DoBlink_WMF_END															; springe

DoBlink_WMF_5:		cpi			r16,33																	; wenn stepcounter unter 33
					brlo		DoBlink_WMF_6															; springe

					sts			PORTB_OUTSET,r17														; schalte prozes led ein

					jmp			DoBlink_WMF_END															; springe

DoBlink_WMF_6:		sts			PORTB_OUTCLR,r17														; schalte prozes led aus

DoBlink_WMF_END:	dec			r16																		; stepcounter -1
					
					jmp			DoBlink_END

;-------------------------------------------------------------------------------------------------------
DoBlink_PDM:		lds			r16,CVAR_SRAM_MAIN_BLINK_CNT1											; lade stepcounter 1 in r16
					
					lds			r17,CVAR_SRAM_MAIN_BLINK_CNT2											; lade stepcounter 2 in r17
					cpi			r17,4																	; vergleiche stepcounter mit priorittszahl
					breq		DoBlink_PDM_0															; springe, wenn identisch

					clr			r16																		; resette stepcounter 1

DoBlink_PDM_0:		ldi			r17,0b00001000															; lade bitmuster fr prozess led in r17
					
					cpi			r16,0																	; wenn stepcounter nicht null
					brne		DoBlink_PDM_1															; springe

					ldi			r16,4																	; lade priorittszahl in r16
					sts			CVAR_SRAM_MAIN_BLINK_CNT2,r16											; speichere priorittszahl in stepcounter 2

					ldi			r16,66																	; lade schrittzhler mit neuem startwert

DoBlink_PDM_1:		cpi			r16,65																	; wenn stepcounter unter 65
					brlo		DoBlink_PDM_2															; springe
					
					sts			PORTB_OUTSET,r17														; schalte prozes led ein

					jmp			DoBlink_PDM_END															; springe

DoBlink_PDM_2:		sts			PORTB_OUTCLR,r17														; schalte prozes led aus

DoBlink_PDM_END:	dec			r16																		; stepcounter -1
					
					jmp			DoBlink_END

;-------------------------------------------------------------------------------------------------------
DoBlink_PRM:		lds			r16,CVAR_SRAM_MAIN_BLINK_CNT1											; lade stepcounter 1 in r16
					
					lds			r17,CVAR_SRAM_MAIN_BLINK_CNT2											; lade stepcounter 2 in r17
					cpi			r17,5																	; vergleiche stepcounter mit priorittszahl
					breq		DoBlink_PRM_0															; springe, wenn identisch

					clr			r16																		; resette stepcounter 1

DoBlink_PRM_0:		ldi			r17,0b00001000															; lade bitmuster fr prozess led in r17
					
					cpi			r16,0																	; wenn stepcounter nicht null
					brne		DoBlink_PRM_1															; springe

					ldi			r16,5																	; lade priorittszahl in r16
					sts			CVAR_SRAM_MAIN_BLINK_CNT2,r16											; speichere priorittszahl in stepcounter 2

					ldi			r16,16																	; lade schrittzhler mit neuem startwert

DoBlink_PRM_1:		sbrc		r16,0																	; wenn bit0 gesetzt ist
					sts			PORTB_OUTCLR,r17														; schalte prozess led aus
					sbrs		r16,0																	; wenn bit0 nicht gesetzt ist
					sts			PORTB_OUTSET,r17														; schalte prozess led an

					dec			r16																		; stepcounter -1

					jmp			DoBlink_END

;-------------------------------------------------------------------------------------------------------
DoBlink_SUP:		lds			r16,CVAR_SRAM_MAIN_BLINK_CNT1											; lade stepcounter 1 in r16
					
					lds			r17,CVAR_SRAM_MAIN_BLINK_CNT2											; lade stepcounter 2 in r17
					cpi			r17,6																	; vergleiche stepcounter mit priorittszahl
					breq		DoBlink_SUP_0															; springe, wenn identisch

					clr			r16																		; resette stepcounter 1

DoBlink_SUP_0:		ldi			r17,0b00001000															; lade bitmuster fr prozess led in r17

					cpi			r16,0																	; wenn stepcounter nicht null
					brne		DoBlink_SUP_1															; springe

					ldi			r16,6																	; lade priorittszahl in r16
					sts			CVAR_SRAM_MAIN_BLINK_CNT2,r16											; speichere priorittszahl in stepcounter 2

					ldi			r16,16																	; lade schrittzhler mit neuem startwert

DoBlink_SUP_1:		sbrc		r16,1																	; wenn bit1 gesetzt ist
					sts			PORTB_OUTCLR,r17														; schalte prozess led aus
					sbrs		r16,1																	; wenn bit1 nicht gesetzt ist
					sts			PORTB_OUTSET,r17														; schalte prozess led an

					dec			r16																		; stepcounter -1
					
					jmp			DoBlink_END

;-------------------------------------------------------------------------------------------------------
DoBlink_NOM:		lds			r16,CVAR_SRAM_MAIN_BLINK_CNT1											; lade stepcounter 1 in r16
					
					lds			r17,CVAR_SRAM_MAIN_BLINK_CNT2											; lade stepcounter 2 in r17
					cpi			r17,7																	; vergleiche stepcounter mit priorittszahl
					breq		DoBlink_NOM_0															; springe, wenn identisch

					clr			r16																		; resette stepcounter 1

DoBlink_NOM_0:		ldi			r17,0b00001000															; lade bitmuster fr prozess led in r17

					cpi			r16,0																	; wenn stepcounter nicht null
					brne		DoBlink_NOM_1															; springe

					ldi			r16,7																	; lade priorittszahl in r16
					sts			CVAR_SRAM_MAIN_BLINK_CNT2,r16											; speichere priorittszahl in stepcounter 2

					ldi			r16,16																	; lade schrittzhler mit neuem startwert

DoBlink_NOM_1:		sbrc		r16,3																	; wenn bit3 gesetzt ist
					sts			PORTB_OUTCLR,r17														; schalte prozess led aus
					sbrs		r16,3																	; wenn bit3 nicht gesetzt ist
					sts			PORTB_OUTSET,r17														; schalte prozess led an

					dec			r16																		; stepcounter -1

					jmp			DoBlink_END

;-------------------------------------------------------------------------------------------------------
DoBlink_CLR:		ldi			r17,0b00001000															; schalte prozess led aus
					sts			PORTB_OUTCLR,r17														; "

					jmp			DoBlink_END2															; springe

;-------------------------------------------------------------------------------------------------------