;-erzeugt eine piepfolge entsprechend dem wert im RAM---------------------------------
; CVAR_SRAM_MAIN_PEEP_CON
; 0x00 : ton aus

; 0x01 : 1 Submodul erkannt (1x kurz)
; 0x02 : 2 Submodule erkannt (2x kurz)
; 0x03 : 3 Submodule erkannt (3x kurz)
; 0x04 : 4 Submodule erkannt (4x kurz)
; 0x05 : 5 Submodule erkannt (5x kurz)
; 0x06 : 6 Submodule erkannt (6x kurz)
; 0x07 : 7 Submodule erkannt (7x kurz)

; 0x10 : Fehler im Submodul Slave A1 (1x lang)
; 0x20 : Fehler im Submodul Slave A2 (2x lang)
; 0x30 : Fehler im Submodul Slave A3 (3x lang)
; 0x40 : Fehler im Submodul Slave A4 (4x lang)
; 0x50 : Fehler im Submodul Slave A5 (5x lang)
; 0x60 : Fehler im Submodul Slave B1 (6x lang)
; 0x70 : Fehler im Submodul Slave B2 (7x lang)
DoPeep:				push		r16
					in			r16,CPU_SREG
					push		r16
					push		r17

					lds			r16,CVAR_SRAM_MAIN_PEEP_CNT											; lade stepcounter aus ram in r16

					lds			r17,CVAR_SRAM_MAIN_STATUS_2											; lade statusbyte 2 aus ram in r17
					sbrc		r17,2																; wenn warfare flag gesetzt ist
					jmp			DoPeep_SLC_1														; springe

					lds			r17,CVAR_SRAM_MAIN_PEEP_CON											; lade auszufhrende tonfolge in r17
					cpi			r17,0																; wenn keine tonfolge gewhlt
					breq		DoPeep_SLC_1														; springe
					
DoPeep_SMC1:		cpi			r17,16																; wenn fehlermeldungen gewhlt wurden
					brsh		DoPeep_SMC2															; springe

					dec			r16																	; reduziere stepcounter

					cpi			r16,-1																; wenn stepcounter nicht -1
					brne		DoPeep_SMC1_1														; springe

					andi		r17,0b00001111														; entferne oberes halbbyte
					lsl			r17																	; multipliziere gewhlte tonfolge mit 2 (errechnung der bentigten schritte)
					mov			r16,r17																; kopiere errechneten wert in stepcounter

DoPeep_SMC1_1:		cpi			r16,0																; wenn stepcounter gleich null
					breq		DoPeep_SLC_2														; springe

					lds			r17,TCC1_CTRLB														; lade zustand des port overwrite tcc1 in r17

					sbrs		r16,0																; wenn bit0 des stepcounter 0 ist
					ori			r17,0b00010000														; setze port overwrite tcc1 bit
					sbrc		r16,0																; wenn bit0 des stepcounter 1 ist
					andi		r17,0b11101111														; lsche port overwrite tcc1 bit

					sts			TCC1_CTRLB,r17														; schreibe neuen port overwrite tcc1 in ram

					jmp			DoPeep_END															; springe

DoPeep_SMC2:		dec			r16																	; reduziere stepcounter

					cpi			r16,-1																; wenn stepcounter nicht -1
					brne		DoPeep_SMC2_1														; springe

					andi		r17,0b11110000														; entferne unteres halbbyte
					lsr			r17																	; multipliziere gewhlte tonfolge mit 4 (errechnung der bentigten schritte)
					lsr			r17																	; "
					mov			r16,r17																; kopiere errechneten wert in stepcounter

DoPeep_SMC2_1:		cpi			r16,0																; wenn stepcounter gleich null
					breq		DoPeep_SLC_2														; springe

					lds			r17,TCC1_CTRLB														; lade zustand des port overwrite tcc1 in r17

					sbrc		r16,1																; wenn bit1 des stepcounter 0 ist
					ori			r17,0b00010000														; setze port overwrite tcc1 bit
					sbrs		r16,1																; wenn bit1 des stepcounter 1 ist
					andi		r17,0b11101111														; lsche port overwrite tcc1 bit

					sts			TCC1_CTRLB,r17														; schreibe neuen port overwrite tcc1 in ram

DoPeep_END:			sts			CVAR_SRAM_MAIN_PEEP_CNT,r16											; schreibe stepcounter in ram

					pop			r17
					pop			r16
					out			CPU_SREG,r16
					pop			r16
					ret

;--------------------------------------------------------------------------------------------------------
DoPeep_SLC_1:		lds			r17,TCC1_CTRLB														; deaktiviere port overwrite von tcc1
					andi		r17,0b11101111														; "
					sts			TCC1_CTRLB,r17														; "

					ldi			r17,0b00010000														; setze piepser ausgang auf 0
					sts			PORTC_OUTCLR,r17													; "
					
					jmp			DoPeep_END															; springe

;-------------------------------------------------------------------------------------------------------
DoPeep_SLC_2:		ldi			r17,0																; resette gewhlte tonfolge
					sts			CVAR_SRAM_MAIN_PEEP_CON,r17											; speichere "keine tonfolge" im ram
					
					lds			r17,TCC1_CTRLB														; deaktiviere port overwrite von tcc1
					andi		r17,0b11101111														; "
					sts			TCC1_CTRLB,r17														; "

					ldi			r17,0b00010000														; setze piepser ausgang auf 0
					sts			PORTC_OUTCLR,r17													; "
					
					jmp			DoPeep_END															; springe

;-------------------------------------------------------------------------------------------------------
