;-schreibe alle steuerwerte aus eeprom in ram (max 250 Bytes)-------------------------------------------------------
EEPROMWrite:		push		r16
					in			r16,CPU_SREG
					push		r16
					push		r17
					push		r18
					push		r28
					push		r29
					push		r30
					push		r31

EEPROMWrite1:		lds			r16,NVM_STATUS														; warte bis Memory Control bereit
					sbrc		r16,7																; "
					jmp			EEPROMWrite1														; "
					
					lds			r16,MAPPED_EEPROM_START												; lade anzahl der eeprom bytes in r16
					clr			r17																	; resette r17
					
					ldi			r28,low(CVAR_SRAM_REMOTECON_START)									; lade erste adresse des remote control ram bereiches in Y
					ldi			r29,high(CVAR_SRAM_REMOTECON_START)									; "
					ldi			r30,low(MAPPED_EEPROM_START + 1)									; lade erste adresse des gemappten eeprom bereiches in Z
					ldi			r31,high(MAPPED_EEPROM_START + 1)									; "

					add			r16,r30																; addiere byteanzahl mit eeprom startadresse
					adc			r17,r31																; "

EEPROMWrite2:		ld			r18,Y+																; lade wert aus eeprom in r18
					st			Z+,r18																; speichere wert in am

					cp			r30,r16																; solange letzte eeprom nicht berschritten
					brne		EEPROMWrite2														; springe
					cp			r31,r17																; "
					brne		EEPROMWrite2														; "

					lds			r16,MAPPED_EEPROM_START												; lade anzahl der eeprom bytes in r16
					clr			r17																	; resette r17
					ldi			r30,low(EEPROM_START + 1)											; lade erste eeprom adresse + 1 in Z
					ldi			r31,high(EEPROM_START + 1)											; "
					add			r16,r30																; addiere Z zum bytezhler
					adc			r17,r31																; "

EEPROMWrite3:		lds			r18,NVM_STATUS														; warte bis Memory Control bereit
					sbrc		r18,7																; "
					jmp			EEPROMWrite3														; "

					clr			r18																	; lsche r18
					sts			NVM_ADDR0,r30														; setze zu speichernde adresse
					sts			NVM_ADDR1,r31														; "
					sts			NVM_ADDR2,r18														; "

					ldi			r18,0xD8															; lade Bitmuster zum ndern von IO Register
					out			CPU_CCP,r18															; schreibe nder-Bitmuster in CCP
					ldi			r18,0b00000001														; schreibe eeprom
					sts			NVM_CTRLA,r18														; "

					adiw		r30,CVAR_EEPROM_PAGESIZE											; setze Z auf nchste page

					cp			r30,r16																; wenn letzte genutzte eeprom adresse nicht berschritten
					cpc			r31,r17																; "
					brlo		EEPROMWrite3														; springe

					pop			r31
					pop			r30
					pop			r29
					pop			r28
					pop			r18
					pop			r17
					pop			r16
					out			CPU_SREG,r16
					pop			r16
					ret

;---------------------------------------------------------------------------------------------------