;-initialisierung der SPI Slaves auf Bus C--------------------------------------------------------
InitSPICSlaves:				push		r16
							push		r30
							push		r31

							;-Startvorgang fr SPI Bus C-----------------------------------------
							ldi			r30,low(CVAR_SRAM_SPIC_PX_READ_START)				; lade startadresse der portexpander lese/schreib sequenz in Z
							ldi			r31,high(CVAR_SRAM_SPIC_PX_READ_START)				; "

							ldi			r16,0x41											; lesebefehl
							st			Z+,r16
							ldi			r16,0x09											; auf adresse 9
							st			Z+,r16
							ldi			r16,0x00											; dummy byte
							st			Z+,r16
							ldi			r16,0x40											; schreibbefehl
							st			Z+,r16
							ldi			r16,0x0A											; auf adresse 10
							st			Z+,r16
							ldi			r16,0x00											; "inhalt wird durch SPIC_ISR ersetzt"
							st			Z+,r16
							ldi			r16,0x00											; "inhalt wird durch SPIC_ISR ersetzt"
							st			Z,r16

							ldi			r16,0x00											; starte SPI Bus C durch dummy bertragung
							sts			SPIC_DATA,r16										; "

							ldi			r16,0b00000001										; lade ersten SPIC slave in slaveselector (LCD)
							sts			CVAR_SRAM_SPIC_SLAVESELECTOR,r16					; "

							;-Initialisierung des LCD---------------------------------------------
							ldi			r16,14												; lade bytecount der configurationsbytes in r16
							sts			CVAR_SRAM_SPIC_CONFIGBC2,r16						; schreibe bytecount in ram

							ldi			r30,low(CVAR_SRAM_SPIC_CONFIG_START)				; lade startadresse der SPIC Config Sequenz in Z
							ldi			r31,high(CVAR_SRAM_SPIC_CONFIG_START)				; "

							ldi			r16,0x40											; startline 0
							st			Z+,r16
							ldi			r16,0xA0											; ADC normal
							st			Z+,r16
							ldi			r16,0xC8											; 180 darstellung Com63 bis Com0
							st			Z+,r16
							ldi			r16,0xA6											; display normal
							st			Z+,r16
							ldi			r16,0xA2											; set bias 1/9
							st			Z+,r16
							ldi			r16,0x2F											; booster, regular and follower on
							st			Z+,r16
							ldi			r16,0xF8											; set internal booster to 4
							st			Z+,r16
							ldi			r16,0x00											; set internal booster to 4
							st			Z+,r16
							ldi			r16,0x27											; contrast set
							st			Z+,r16
							ldi			r16,0x81											; contrast set
							st			Z+,r16
							ldi			r16,0x10											; contrast set
							st			Z+,r16
							ldi			r16,0xAC											; no indicator
							st			Z+,r16
							ldi			r16,0x00											; no indicator
							st			Z+,r16
							ldi			r16,0xAF											; display on
							st			Z,r16

							ldi			r16,0b00000001										; setze lcd auf Configuration
							sts			CVAR_SRAM_SPIC_MODESELECTOR,r16						; "

InitSPICSlaves1:			lds			r16,CVAR_SRAM_SPIC_MODESELECTOR						; warte das configuration abgeschlossen wurde
							sbrc		r16,0												; "
							jmp			InitSPICSlaves1										; "

							;-Initialisierung des Portexpander 1---------------------------------------------
							ldi			r16,12												; lade bytecount der configurationsbytes in r16
							sts			CVAR_SRAM_SPIC_CONFIGBC2,r16						; schreibe bytecount in ram

							ldi			r30,low(CVAR_SRAM_SPIC_CONFIG_START)				; lade startadresse der SPIC Config Sequenz in Z
							ldi			r31,high(CVAR_SRAM_SPIC_CONFIG_START)				; "

							ldi			r16,0x40											; schreibbefehl
							st			Z+,r16
							ldi			r16,0x00											; erste portexpander adresse
							st			Z+,r16
							ldi			r16,0b00000000										; Directory
							st			Z+,r16
							ldi			r16,0b00000000										; pins invertieren
							st			Z+,r16
							ldi			r16,0b00000000										; interrupt on change
							st			Z+,r16
							ldi			r16,0b00000000										; default compare
							st			Z+,r16
							ldi			r16,0b00000000										; interrupt control
							st			Z+,r16
							ldi			r16,0b00000000										; configuration
							st			Z+,r16
							ldi			r16,0b00000000										; pull-up resistors
							st			Z+,r16
							ldi			r16,0b00000000										; interrupt flags ("don't care)
							st			Z+,r16
							ldi			r16,0b00000000										; interrupt capture (don't care)
							st			Z+,r16
							ldi			r16,0b00000000										; GPIO (Output Latch)
							st			Z,r16

							ldi			r16,0b00000010										; setze portex1 auf Configuration
							sts			CVAR_SRAM_SPIC_MODESELECTOR,r16						; "

InitSPICSlaves2:			lds			r16,CVAR_SRAM_SPIC_MODESELECTOR						; warte das configuration abgeschlossen wurde
							sbrc		r16,1												; "
							jmp			InitSPICSlaves2										; "

							;-Initialisierung des Portexpander 2---------------------------------------------
							ldi			r16,12												; lade bytecount der configurationsbytes in r16
							sts			CVAR_SRAM_SPIC_CONFIGBC2,r16						; schreibe bytecount in ram

							ldi			r30,low(CVAR_SRAM_SPIC_CONFIG_START)				; lade startadresse der SPIC Config Sequenz in Z
							ldi			r31,high(CVAR_SRAM_SPIC_CONFIG_START)				; "

							ldi			r16,0x40											; schreibbefehl
							st			Z+,r16
							ldi			r16,0x00											; erste portexpander adresse
							st			Z+,r16
							ldi			r16,0b11111111										; Directory
							st			Z+,r16
							ldi			r16,0b00000000										; pins invertieren
							st			Z+,r16
							ldi			r16,0b00000000										; interrupt on change
							st			Z+,r16
							ldi			r16,0b00000000										; default compare
							st			Z+,r16
							ldi			r16,0b00000000										; interrupt control
							st			Z+,r16
							ldi			r16,0b00000000										; configuration
							st			Z+,r16
							ldi			r16,0b11111111										; pull-up resistors
							st			Z+,r16
							ldi			r16,0b00000000										; interrupt flags ("don't care)
							st			Z+,r16
							ldi			r16,0b00000000										; interrupt capture (don't care)
							st			Z,r16
							ldi			r16,0b00000000										; GPIO (Output Latch)
							st			Z,r16

							ldi			r16,0b00000100										; setze portex2 auf Configuration
							sts			CVAR_SRAM_SPIC_MODESELECTOR,r16						; "

InitSPICSlaves3:			lds			r16,CVAR_SRAM_SPIC_MODESELECTOR						; warte das configuration abgeschlossen wurde
							sbrc		r16,2												; "
							jmp			InitSPICSlaves3										; "

							pop			r31
							pop			r30
							pop			r16
							ret

;-------------------------------------------------------------------------------------------------