;-Initialisierung der Hauptkomponenten--------------------------------------------------------------
					; resette Multiport configuration register
MainInit:			ldi			r16,0b00000000								; lade nullen in Multiportregister
					sts			PORTCFG_MPCMASK,r16							; "

					; Konfiguration Port A
					ldi			r16,0b00000000								; output wird nicht verwendet
					sts			PORTA_OUT,r16

					ldi			r16,0b00000000								; alle pins sind eingnge
					sts			PORTA_DIR,r16

					ldi			r16,0b00000000								; kein interrupt aktiviert
					sts			PORTA_INTCTRL,r16

					ldi			r16,0b00000000								; kein pin auf interrupt 0
					sts			PORTA_INT0MASK,r16

					ldi			r16,0b00000000								; kein pin auf interrupt 1
					sts			PORTA_INT1MASK,r16

					ldi			r16,0b00000000								; nicht invertieren, keine pullup / down
					sts			PORTA_PIN0CTRL,r16
					sts			PORTA_PIN1CTRL,r16
					sts			PORTA_PIN2CTRL,r16
					sts			PORTA_PIN3CTRL,r16
					sts			PORTA_PIN4CTRL,r16
					sts			PORTA_PIN5CTRL,r16
					sts			PORTA_PIN6CTRL,r16
					sts			PORTA_PIN7CTRL,r16

					; Konfiguration Port B
					ldi			r16,0b00000000								; ausgang beginnt mit low level
					sts			PORTB_OUT,r16

					ldi			r16,0b00001000								; nur pin 3 auf ausgang
					sts			PORTB_DIR,r16

					ldi			r16,0b00000000								; kein interrupt aktiviert
					sts			PORTB_INTCTRL,r16

					ldi			r16,0b00000000								; kein pin auf interrupt 0
					sts			PORTB_INT0MASK,r16

					ldi			r16,0b00000000								; kein pin auf interrupt 1
					sts			PORTB_INT1MASK,r16

					ldi			r16,0b00000000								; keine invertierung, pullup nur fr pin2 aktivieren
					sts			PORTB_PIN0CTRL,r16
					sts			PORTB_PIN1CTRL,r16
					ldi			r16,0b00011000
					sts			PORTB_PIN2CTRL,r16
					ldi			r16,0b00000000
					sts			PORTB_PIN3CTRL,r16
					sts			PORTB_PIN4CTRL,r16
					sts			PORTB_PIN5CTRL,r16
					sts			PORTB_PIN6CTRL,r16
					sts			PORTB_PIN7CTRL,r16

					; Konfiguration Port C
					ldi			r16,0b00000100								; pin 2 ist initial high
					sts			PORTC_OUT,r16

					ldi			r16,0b10110111								; nur pin3 und 6 auf eingang
					sts			PORTC_DIR,r16

					ldi			r16,0b00000000								; kein interrupt aktiviert
					sts			PORTC_INTCTRL,r16

					ldi			r16,0b00000000								; kein pin auf interrupt 0
					sts			PORTC_INT0MASK,r16

					ldi			r16,0b00000000								; kein pin auf interrupt 1
					sts			PORTC_INT1MASK,r16

					ldi			r16,0b00000000								; keine invertierung, pin 3 pullup
					sts			PORTC_PIN0CTRL,r16
					sts			PORTC_PIN1CTRL,r16
					sts			PORTC_PIN2CTRL,r16
					ldi			r16,0b00011000
					sts			PORTC_PIN3CTRL,r16
					ldi			r16,0b00000000
					sts			PORTC_PIN4CTRL,r16
					sts			PORTC_PIN5CTRL,r16
					sts			PORTC_PIN6CTRL,r16
					sts			PORTC_PIN7CTRL,r16

					; Konfiguration Port D
					ldi			r16,0b00011000								; pin 3 und 4 sind initial high
					sts			PORTD_OUT,r16

					ldi			r16,0b10111000								; pin 3, 4, 5 und 7 sind ausgnge
					sts			PORTD_DIR,r16

					ldi			r16,0b00000000								; kein interrupt aktiviert
					sts			PORTD_INTCTRL,r16

					ldi			r16,0b00000000								; kein pin auf interrupt 0
					sts			PORTD_INT0MASK,r16

					ldi			r16,0b00000000								; kein pin auf interrupt 1
					sts			PORTD_INT1MASK,r16

					ldi			r16,0b00011000								; pin0 bis 2 bekommt einen pullup, kein pin wird invertiert
					sts			PORTD_PIN0CTRL,r16
					sts			PORTD_PIN1CTRL,r16
					sts			PORTD_PIN2CTRL,r16
					ldi			r16,0b00000000
					sts			PORTD_PIN3CTRL,r16
					sts			PORTD_PIN4CTRL,r16
					sts			PORTD_PIN5CTRL,r16
					sts			PORTD_PIN6CTRL,r16
					sts			PORTD_PIN7CTRL,r16

					; Konfiguration Port E
					ldi			r16,0b00000000								; initialzustand 0
					sts			PORTE_OUT,r16

					ldi			r16,0b00001000								; pin3 wird ausgang
					sts			PORTE_DIR,r16

					ldi			r16,0b00000000								; kein interrupt aktiviert
					sts			PORTE_INTCTRL,r16

					ldi			r16,0b00000000								; kein pin auf interrupt 0
					sts			PORTE_INT0MASK,r16

					ldi			r16,0b00000000								; kein pin auf interrupt 1
					sts			PORTE_INT1MASK,r16

					ldi			r16,0b00000000								; nur pin 1 bekommt einen pullup, kein pin wird invertiert
					sts			PORTE_PIN0CTRL,r16
					ldi			r16,0b00011000
					sts			PORTE_PIN1CTRL,r16
					ldi			r16,0b00000000
					sts			PORTE_PIN2CTRL,r16
					sts			PORTE_PIN3CTRL,r16
					sts			PORTE_PIN4CTRL,r16
					sts			PORTE_PIN5CTRL,r16
					sts			PORTE_PIN6CTRL,r16
					sts			PORTE_PIN7CTRL,r16

					; Konfiguration Port R
					ldi			r16,0b00000000								; out hat keine funktion
					sts			PORTR_OUT,r16

					ldi			r16,0b00000000								; alle pins sind eingnge
					sts			PORTR_DIR,r16

					ldi			r16,0b00000000								; kein interrupt aktiviert
					sts			PORTR_INTCTRL,r16

					ldi			r16,0b00000000								; kein pin auf interrupt 0
					sts			PORTR_INT0MASK,r16

					ldi			r16,0b00000000								; kein pin auf interrupt 1
					sts			PORTR_INT1MASK,r16

					ldi			r16,0b00000000								; kein pullup / down, keine invertierung
					sts			PORTR_PIN0CTRL,r16
					sts			PORTR_PIN1CTRL,r16
					sts			PORTR_PIN2CTRL,r16
					sts			PORTR_PIN3CTRL,r16
					sts			PORTR_PIN4CTRL,r16
					sts			PORTR_PIN5CTRL,r16
					sts			PORTR_PIN6CTRL,r16
					sts			PORTR_PIN7CTRL,r16

					; Initial zustnde der externen ports
					ldi			r16,0b00000000								; portex1 out setzen
					sts			CVAR_SRAM_PORTX1_OUTPUT,r16					; "

					ldi			r16,0b00000000								; portex1 dir setzen
					sts			CVAR_SRAM_PORTX1_DIR,r16					; "

					ldi			r16,0b00000000								; portex2 out setzen
					sts			CVAR_SRAM_PORTX2_OUTPUT,r16					; "

					ldi			r16,0b11111111								; portex2 dir setzen
					sts			CVAR_SRAM_PORTX2_DIR,r16					; "

					; Interrupt Level Konfiguration
					ldi			r16,0b00000000								; muss null sein, bei deaktivierter ring-abarbeitung
					sts			PMIC_INTPRI,r16
					
					ldi			r16,0b00000111								; keine ring-abarbeitung, vectoren nicht im bootsector, alle level aktiviert
					sts			PMIC_CTRL,r16
					
					; Konfiguration SPI C
					ldi			r16,0b00000011								; enable interrupt mit level high
					sts			SPIC_INTCTRL,r16							; "
					
					ldi			r16,(0b01010000	| CVAR_SPIC_Pre)			; enable SPIC im Mastermode mit vorteiler
					sts			SPIC_CTRL,r16								; "

					; Konfiguration SPI D
					ldi			r16,0b00000011								; enable interrupt mit level high
					sts			SPID_INTCTRL,r16							; "
					
					ldi			r16,(0b01010000 | CVAR_SPID_Pre)			; enable SPIC im Mastermode mit vorteiler
					sts			SPID_CTRL,r16								; "

					; Konfiguration DMA
					ldi			r16,0b00000000								; kein double buffer, ringabarbeitung ch0-3
					sts			DMA_CTRL,r16

					ldi			r16,0b10000101								; enable ch0, single shot mode, 2byte burst
					sts			DMA_CH0_CTRLA,r16

					ldi			r16,0b00000000								; ch0 kein interrupt
					sts			DMA_CH0_CTRLB,r16
					
					ldi			r16,0b10010101								; quelle inkrementiert, reset nach burst, ziel inkrementiert, reset nach block
					sts			DMA_CH0_ADDRCTRL,r16
					
					ldi			r16,0b00010000								; dma channel0 trigger ist ADCA
					sts			DMA_CH0_TRIGSRC,r16
					
					ldi			r16,low(CVAR_ADCA_BSIZE)					; lade blockgre
					sts			(DMA_CH0_TRFCNT + 0),r16
					ldi			r16,high(CVAR_ADCA_BSIZE)
					sts			(DMA_CH0_TRFCNT + 1),r16

					ldi			r16,low(ADCA_CH0_RES)						; lade erste quelladresse
					sts			DMA_CH0_SRCADDR0,r16
					ldi			r16,high(ADCA_CH0_RES)
					sts			DMA_CH0_SRCADDR1,r16
					clr			r16 
					sts			DMA_CH0_SRCADDR2,r16

					ldi			r16,low(CVAR_SRAM_ADC_START)				; lade erste ziel adresse des ram
					sts			DMA_CH0_DESTADDR0,r16
					ldi			r16,high(CVAR_SRAM_ADC_START)
					sts			DMA_CH0_DESTADDR1,r16
					clr			r16
					sts			DMA_CH0_DESTADDR2,r16

					; Konfiguration ADC A
					ldi			r16,0b00000001								; enable ADC
					sts			ADCA_CTRLA,r16

					ldi			r16,0b00000000								; mode auf unsigned, single conversion und 12bit right-adjust
					sts			ADCA_CTRLB,r16

					ldi			r16,0b00010000								; bandgab disabled, keine temp ref, Referenz auf interne Vcc/1,6
					sts			ADCA_REFCTRL,r16

					ldi			r16,0b00000000								; keine events aktivieren
					sts			ADCA_EVCTRL,r16

					ldi			r16,CVAR_ADCA_Pre							; Vorteiler setzen
					sts			ADCA_PRESCALER,r16

					ldi			r16,0b00001111								; resette die interrupt flags
					sts			ADCA_INTFLAGS,r16

					ldi			r16,0b00000001								; ch0 gain 1 und single ended
					sts			ADCA_CH0_CTRL,r16

					ldi			r16,0b00000000								; ch0 multiplexer auf pin0 stellen	
					sts			ADCA_CH0_MUXCTRL,r16

					ldi			r16,0b00000011								; ch0 conversion complete high level interrupt
					sts			ADCA_CH0_INTCTRL,r16

					ldi			r16,0b00000001								; resette interrupt flag
					sts			ADCA_CH0_INTFLAGS,r16

					ldi			r16,0b00000101								; start conversion auf ch0
					sts			ADCA_CTRLA,r16

					; Konfiguration Timer C0 (periodische abarbeitungen)
					ldi			r16,0b00000000								; Normal Operation
					sts			TCC0_CTRLB,r16

					ldi			r16,0b00000000								; output compare pins nicht beeinflussen
					sts			TCC0_CTRLC,r16

					ldi			r16,0b00000000								; event system disable
					sts			TCC0_CTRLD,r16

					ldi			r16,0b00000000								; timer arbeitet im 16bit modus
					sts			TCC0_CTRLE,r16

					ldi			r16,0b00000000								; keine interrupts
					sts			TCC0_INTCTRLA,r16
					
					ldi			r16,0b00001111								; enable compare A und B interrupt mit high level
					sts			TCC0_INTCTRLB,r16

					ldi			r16,low(CVAR_TCC0_Per)						; lade periodendauer
					sts			(TCC0_PER + 0),r16
					ldi			r16,high(CVAR_TCC0_Per)
					sts			(TCC0_PER + 1),r16

					ldi			r16,low(CVAR_TCC0_CpA)						; lade compare wert A
					sts			(TCC0_CCA + 0),r16
					ldi			r16,high(CVAR_TCC0_CpA)
					sts			(TCC0_CCA + 1),r16

					ldi			r16,low(CVAR_TCC0_CpB)						; lade compare wert B
					sts			(TCC0_CCB + 0),r16
					ldi			r16,high(CVAR_TCC0_CpB)
					sts			(TCC0_CCB + 1),r16

					ldi			r16,low(CVAR_TCC0_CpB)						; lade compare wert C
					sts			(TCC0_CCC + 0),r16
					ldi			r16,high(CVAR_TCC0_CpB)
					sts			(TCC0_CCC + 1),r16

					ldi			r16,low(CVAR_TCC0_CpB)						; lade compare wert D
					sts			(TCC0_CCD + 0),r16
					ldi			r16,high(CVAR_TCC0_CpB)
					sts			(TCC0_CCD + 1),r16

					ldi			r16,CVAR_TCC0_Pre							; lade vorteiler (enable timer)
					sts			TCC0_CTRLA,r16

					; Konfiguration Timer C1 (pieper)
					ldi			r16,0b00000001								; frequenzy generation mode
					sts			TCC1_CTRLB,r16

					ldi			r16,0b00000000								; output compare pins nicht beeinflussen
					sts			TCC1_CTRLC,r16

					ldi			r16,0b00000000								; event system disable
					sts			TCC1_CTRLD,r16

					ldi			r16,0b00000000								; timer arbeitet im 16bit modus
					sts			TCC1_CTRLE,r16

					ldi			r16,0b00000000								; keine interrupts
					sts			TCC1_INTCTRLA,r16
					
					ldi			r16,0b00000000								; keine interrupts
					sts			TCC1_INTCTRLB,r16

					ldi			r16,low(CVAR_TCC1_Per)						; lade periodendauer
					sts			(TCC1_PER + 0),r16
					ldi			r16,high(CVAR_TCC1_Per)
					sts			(TCC1_PER + 1),r16

					ldi			r16,low(CVAR_TCC1_CpA)						; lade compare wert A
					sts			(TCC1_CCA + 0),r16
					ldi			r16,high(CVAR_TCC1_CpA)
					sts			(TCC1_CCA + 1),r16

					ldi			r16,low(CVAR_TCC1_CpB)						; lade compare wert B
					sts			(TCC1_CCB + 0),r16
					ldi			r16,high(CVAR_TCC1_CpB)
					sts			(TCC1_CCB + 1),r16

					ldi			r16,CVAR_TCC1_Pre							; lade vorteiler (enable timer)
					sts			TCC1_CTRLA,r16

					; Konfiguration Timer D1 (quadratur decoder)
					ldi			r16,0b00000000								; normal mode
					sts			TCD1_CTRLB,r16

					ldi			r16,0b00000000								; output compare pins nicht beeinflussen
					sts			TCD1_CTRLC,r16

					ldi			r16,0b01101000								; event action quadratur decoding auf event channel 0
					sts			TCD1_CTRLD,r16

					ldi			r16,0b00000000								; timer arbeitet im 16bit modus
					sts			TCD1_CTRLE,r16

					ldi			r16,0b00000000								; keine interrupts
					sts			TCD1_INTCTRLA,r16
					
					ldi			r16,0b00000000								; keine interrupts
					sts			TCD1_INTCTRLB,r16

					ldi			r16,low(CVAR_TCD1_Per)						; lade periodendauer
					sts			(TCD1_PER + 0),r16
					ldi			r16,high(CVAR_TCD1_Per)
					sts			(TCD1_PER + 1),r16

					ldi			r16,low(CVAR_TCD1_CpA)						; lade compare wert A
					sts			(TCD1_CCA + 0),r16
					ldi			r16,high(CVAR_TCD1_CpA)
					sts			(TCD1_CCA + 1),r16

					ldi			r16,low(CVAR_TCD1_CpB)						; lade compare wert B
					sts			(TCD1_CCB + 0),r16
					ldi			r16,high(CVAR_TCD1_CpB)
					sts			(TCD1_CCB + 1),r16

					ldi			r16,CVAR_TCD1_Pre							; lade vorteiler (enable timer)
					sts			TCD1_CTRLA,r16

					; Konfiguration Event system
					ldi			r16,0b00001001								; enable channel0 quadratur decoder und digitaler filterung (2 sample)
					sts			EVSYS_CH0CTRL,r16

					ldi			r16,0b01101000								; enable channel0 mit multiplexer source auf portd.0
					sts			EVSYS_CH0MUX,r16

					; Konfiguration UART E0
					ldi			r16,0b00110011								; enable highlevel interrupt, fr data register empty und receive complete
					sts			USARTE0_CTRLA,r16

					ldi			r16,0b00000011								; async mode, keine paritt, 1 stopbit, 8 datenbits
					sts			USARTE0_CTRLC,r16

					ldi			r16,low(CVAR_USARTE0_SEL_Init)				; setze baudrate
					sts			USARTE0_BAUDCTRLA,r16
					ldi			r16,CVAR_USARTE0_FRC_Init
					swap		r16
					ori			r16,high(CVAR_USARTE0_SEL_Init)
					sts			USARTE0_BAUDCTRLB,r16

					ldi			r16,0b00011000								; enable transmitter und receiver
					sts			USARTE0_CTRLB,r16

					; Konfiguration Eeprom
					ldi			r16,0b00001000								; enable eeprom io mapping
					sts			NVM_CTRLB,r16

					ldi			r16,0x35									; lade schreibbefehl
					sts			NVM_CMD,r16

;-Register initialisierung------------------------------------------------------------------------------
					clr			r0											; ergebnisse mathematischer befehle
					clr			r1											; "
					clr			r2
					clr			r3
					clr			r4
					clr			r5
					clr			r6
					clr			r7
					clr			r8
					clr			r9
					clr			r10
					clr			r11
					clr			r12
					clr			r13
					clr			r14
					clr			r15

					clr			r16											; Arbeitsregister 1
					clr			r17											; Arbeitsregister 2
					clr			r18											; Arbeitsregister 3
					clr			r19											; Arbeitsregister 4
					clr			r20											; Arbeitsregister 5
					clr			r21											; Arbeitsregister 6
					clr			r22
					clr			r23
					clr			r24
					clr			r25
					clr			r26											; X
					clr			r27											; "
					clr			r28											; Y
					clr			r29											; "
					clr			r30											; Z
					clr			r31											; "

					ret
;--------------------------------------------------------------------------------------------------------