;-SPIC-ISR: configuration und spiegelung der spic slaves via ram------------------------
SPIC_ISR:				push		r16
						in			r16,CPU_SREG
						push		r16
						push		r28
						push		r29
						push		r30
						push		r31

						lds			r30,CVAR_SRAM_SPIC_DATABC_LOW							; lade SPIC Slave Daten Bytecount in Z
						lds			r31,CVAR_SRAM_SPIC_DATABC_HIGH							; Z
					
SPIC_ISR_DEV:			lds			r16,CVAR_SRAM_SPIC_SLAVESELECTOR						; lade SPIC Slave Selector in r16
						sbrc		r16,0													; wenn LCD bit gesetzt
						jmp			SPIC_ISR_LCD											; springe
						sbrc		r16,1													; wenn portexpander 1 bit gesetzt
						jmp			SPIC_ISR_PX1											; springe
						sbrc		r16,2													; wenn portexpander 2 bit gesetzt
						jmp			SPIC_ISR_PX2											; springe

SPIC_ISR_END:			sts			CVAR_SRAM_SPIC_DATABC_LOW,r30							; schreibe neuen SPIC slave daten bytecount in ram
						sts			CVAR_SRAM_SPIC_DATABC_HIGH,r31							; "

						pop			r31
						pop			r30
						pop			r29
						pop			r28
						pop			r16
						out			CPU_SREG,r16
						pop			r16
						reti

;-LCD Datenverarbeitung----------------------------------------------------------------------------
SPIC_ISR_LCD:			ldi			r16,0b00011000											; schalte Portexpander 1 und 2 inaktiv
						sts			PORTD_OUTSET,r16										; "
						ldi			r16,0b00000100											; schalte LCD aktiv
						sts			PORTC_OUTCLR,r16										; "

						lds			r16,CVAR_SRAM_SPIC_MODESELECTOR							; lade modeselector in r16
						sbrc		r16,0													; wenn config bit gesetzt ist
						jmp			SPIC_ISR_LCD_CON										; springe

						lds			r16,CVAR_SRAM_SPIC_CONFIGBC1							; lade Config ByteCount in r16
						cpi			r16,128													; wenn letzte nicht berschritten
						brlo		SPIC_ISR_LCD_DATA										; springe

						ldi			r28,0b00000010											; schalte lcd in Command mode
						sts			PORTC_OUTCLR,r28										; "

						cpi			r16,129													; wenn bytecount 129 oder hher
						brsh		SPIC_ISR_LCD_COL1										; springe

						ldi			r29,0b00010000											; lade highbyte der ersten spalte
						sts			SPIC_DATA,r29											; und sende

						inc			r16														; erhhe bytecount
						sts			CVAR_SRAM_SPIC_CONFIGBC1,r16							; und speichere in ram

						jmp			SPIC_ISR_END											; springe

SPIC_ISR_LCD_COL1:		cpi			r16,130													; wenn bytecount 130 oder hher
						brsh		SPIC_ISR_LCD_COL2										; springe

						ldi			r29,0b00000100											; lade lowbyte der ersten spalte
						sts			SPIC_DATA,r29											; und sende

						inc			r16														; erhhe bytecount
						sts			CVAR_SRAM_SPIC_CONFIGBC1,r16							; und speichere in ram

						jmp			SPIC_ISR_END											; springe

SPIC_ISR_LCD_COL2:		clr			r16														; lsche config bytecount
						sts			CVAR_SRAM_SPIC_CONFIGBC1,r16							; "

						mov			r28,r30													; kopiere daten bytecount von Z in Y
						mov			r29,r31													; "
						rol			r28														; errechne die nchste bentigte lcd page
						rol			r29														; "
						ori			r29,0b10110000											; lege command bitmaske ber page-nummer

						sts			SPIC_DATA,r29											; sende befehl fr nchste lcd page

						cpi			r30,0													; wenn daten bytecount nicht null
						brne		SPIC_ISR_LCD_END										; springe
						cpi			r31,0													; "
						brne		SPIC_ISR_LCD_END										; "

						ldi			r16,0b00000010											; setze slaveselector auf nchsten slave
						sts			CVAR_SRAM_SPIC_SLAVESELECTOR,r16						; "

						jmp			SPIC_ISR_END											; springe

SPIC_ISR_LCD_DATA:		ldi			r16,0b00000010											; schalte lcd in daten modus
						sts			PORTC_OUTSET,r16										; "

						lds			r16,CVAR_SRAM_SPIC_CONFIGBC1							; lade Config ByteCount in r16 
						inc			r16														; erhhe config bytecount um einen
						sts			CVAR_SRAM_SPIC_CONFIGBC1,r16							; schreibe config bytecount in ram

						ldi			r28,low(CVAR_SRAM_LCD_SHADOWRAM_START)					; lade den lcs schattenram start in Y
						ldi			r29,high(CVAR_SRAM_LCD_SHADOWRAM_START)					; "
						add			r28,r30													; addiere daten bytecount zu Y
						adc			r29,r31													; "

						ld			r16,Y													; lade das schattenram daten byte von adresse Y in r16
						sts			SPIC_DATA,r16											; sende das datenbyte

						adiw		r30,1													; erhhe daten bytecount um einen

						cpi			r30,low(CVAR_SRAM_LCD_SHADOWRAM_SIZE)					; wenn letzte schattenram adresse nicht berschritten
						brne		SPIC_ISR_LCD_END										; springe
						cpi			r31,high(CVAR_SRAM_LCD_SHADOWRAM_SIZE)					; "
						brne		SPIC_ISR_LCD_END										; "

						clr			r30														; resette datenbytecount
						clr			r31														; "
						
SPIC_ISR_LCD_END:		jmp			SPIC_ISR_END											; "

;-Portexpander 1 datenverarbeitung----------------------------------------------------------------------------
SPIC_ISR_PX1:			ldi			r16,0b00000100											; schalte lcd und portexpander 2 inaktiv
						sts			PORTC_OUTSET,r16										; "
						ldi			r16,0b00010000											; "
						sts			PORTD_OUTSET,r16										; "
						ldi			r16,0b00001000											; schalte portexpander 1 aktiv
						sts			PORTD_OUTCLR,r16										; "

						cpi			r30,0													; wenn datenbytecount null
						brne		SPIC_ISR_PX1_1											; springe nicht

						lds			r16,CVAR_SRAM_SPIC_MODESELECTOR							; lade modeselector in r16
						sbrc		r16,1													; wenn config bit gesetzt ist
						jmp			SPIC_ISR_PX1_CON										; springe

SPIC_ISR_PX1_1:			lds			r16,CVAR_SRAM_PORTX1_OUTPUT								; kopiere output bitmuster in lese/schreib sequenz
						sts			(CVAR_SRAM_SPIC_PX_READ_START + 5),r16					; "
						lds			r16,CVAR_SRAM_PORTX1_DIR								; kopiere dir bitmuster in lese/schreib sequenz
						sts			(CVAR_SRAM_SPIC_PX_READ_START + 6),r16					; "

						cpi			r30,3													; wenn drittes byte bertragen
						brne		SPIC_ISR_PX1_2											; springe nicht

						lds			r16,SPIC_DATA											; lade input bitmuster in r16
						sts			CVAR_SRAM_PORTX1_INPUT,r16								; speichere input im ram

						ldi			r16,0b00001000											; lade CS steuerbit
						sts			PORTD_OUTSET,r16										; CS high
						nop																	; CS high hold time
						nop																	; "
						nop																	; "
						sts			PORTD_OUTCLR,r16										; CS low

						jmp			SPIC_ISR_PX1_3											; springe

SPIC_ISR_PX1_2:			cpi			r30,7													; wenn letztes byte bertragen
						brne		SPIC_ISR_PX1_3											; springe nicht

						ldi			r16,0b00000100											; setze slaveselector auf nchsten slave
						sts			CVAR_SRAM_SPIC_SLAVESELECTOR,r16						; "

						clr			r30														; resette datenbytecount
						clr			r31														; "

						jmp			SPIC_ISR_DEV											; springe

SPIC_ISR_PX1_3:			ldi			r28,low(CVAR_SRAM_SPIC_PX_READ_START)					; lade die startadresse der lese/schreib sequenz in Y
						ldi			r29,high(CVAR_SRAM_SPIC_PX_READ_START)					; "
						add			r28,r30													; addiere daten bytecount zu Y
						adc			r29,r31													; "

						ld			r16,Y													; lade lese/schreib sequenz byte von adresse Y in r16
						sts			SPIC_DATA,r16											; sende das byte

						adiw		r30,1													; erhhe daten bytecount um einen		
						
SPIC_ISR_PX1_END:		jmp			SPIC_ISR_END											; springe

;-Portexpander 2 datenverarbeitung----------------------------------------------------------------------------
SPIC_ISR_PX2:			ldi			r16,0b00000100											; schalte lcd und portexpander 1 inaktiv
						sts			PORTC_OUTSET,r16										; "
						ldi			r16,0b00001000											; "
						sts			PORTD_OUTSET,r16										; "
						ldi			r16,0b00010000											; schalte portexpander 2 aktiv
						sts			PORTD_OUTCLR,r16										; "

						cpi			r30,0													; wenn datenbytecount null
						brne		SPIC_ISR_PX2_1											; springe nicht

						lds			r16,CVAR_SRAM_SPIC_MODESELECTOR							; lade modeselector in r16
						sbrc		r16,2													; wenn config bit gesetzt ist
						jmp			SPIC_ISR_PX2_CON										; springe

SPIC_ISR_PX2_1:			lds			r16,CVAR_SRAM_PORTX2_OUTPUT								; kopiere output bitmuster in lese/schreib sequenz
						sts			(CVAR_SRAM_SPIC_PX_READ_START + 5),r16					; "
						lds			r16,CVAR_SRAM_PORTX2_DIR								; kopiere dir bitmuster in lese/schreib sequenz
						sts			(CVAR_SRAM_SPIC_PX_READ_START + 6),r16					; "

						cpi			r30,3													; wenn drittes byte bertragen
						brne		SPIC_ISR_PX2_2											; springe nicht

						lds			r16,SPIC_DATA											; lade input bitmuster in r16
						sts			CVAR_SRAM_PORTX2_INPUT,r16								; speichere input im ram

						ldi			r16,0b00010000											; lade CS steuerbit
						sts			PORTD_OUTSET,r16										; CS high
						nop																	; CS high hold time
						nop																	; "
						nop																	; "
						sts			PORTD_OUTCLR,r16										; CS low

						jmp			SPIC_ISR_PX2_3											; springe

SPIC_ISR_PX2_2:			cpi			r30,7													; wenn letztes byte bertragen
						brne		SPIC_ISR_PX2_3											; springe nicht

						ldi			r16,0b00000001											; setze slaveselector auf nchsten slave
						sts			CVAR_SRAM_SPIC_SLAVESELECTOR,r16						; "

						clr			r30														; resette datenbytecount
						clr			r31														; "

						jmp			SPIC_ISR_DEV											; springe

SPIC_ISR_PX2_3:			ldi			r28,low(CVAR_SRAM_SPIC_PX_READ_START)					; lade die startadresse der lese/schreib sequenz in Y
						ldi			r29,high(CVAR_SRAM_SPIC_PX_READ_START)					; "
						add			r28,r30													; addiere daten bytecount zu Y
						adc			r29,r31													; "

						ld			r16,Y													; lade lese/schreib sequenz byte von adresse Y in r16
						sts			SPIC_DATA,r16											; sende das byte

						adiw		r30,1													; erhhe daten bytecount um einen		
						
SPIC_ISR_PX2_END:		jmp			SPIC_ISR_END											; springe

;-LCD Config verarbeitung----------------------------------------------------------------------------
SPIC_ISR_LCD_CON:		ldi			r16,0b00000010											; schalte lcd in Command mode
						sts			PORTC_OUTCLR,r16										; "

						lds			r28,CVAR_SRAM_SPIC_CONFIGBC2							; lade config bytecount 2 in r28
						cpi			r28,0													; wenn bytecount null
						breq		SPIC_ISR_LCD_CON_END									; springe

						lds			r16,CVAR_SRAM_SPIC_CONFIGBC3							; lade config bytecount 3 in r16
						cpi			r16,1													; wenn maxbytecountmerker nicht null
						brsh		SPIC_ISR_LCD_CON_1										; springe

						sts			CVAR_SRAM_SPIC_CONFIGBC3,r28							; lade bytecount in maxbytecountmerker im ram
						mov			r16,r28													; kopiere bytecount in r16

SPIC_ISR_LCD_CON_1:		sub			r16,r28													; subtrahiere bytecount von maxbytecountmerker

						dec			r28														; reduziere bytecount um einen
						sts			CVAR_SRAM_SPIC_CONFIGBC2,r28							; speichere bytecount in ram
						
						ldi			r28,low(CVAR_SRAM_SPIC_CONFIG_START)					; lade erste ram commando adresse in Y
						ldi			r29,high(CVAR_SRAM_SPIC_CONFIG_START)					; "
						add			r28,r16													; addiere subtraktionsergebnis
						clr			r16														; "
						adc			r29,r16													; "

						ld			r16,Y													; lade commandobyte in ram adresse in Y in r16

						sts			SPIC_DATA,r16											; sende commando

						jmp			SPIC_ISR_END											; springe
						
SPIC_ISR_LCD_CON_END:	clr			r16														; lade nullen in r16
						sts			CVAR_SRAM_SPIC_CONFIGBC3,r16							; schreibe nullen in maxbytecountmerker

						lds			r16,CVAR_SRAM_SPIC_MODESELECTOR							; lade modeselector in r16
						andi		r16,0b11111110											; lsche lcd config bit
						sts			CVAR_SRAM_SPIC_MODESELECTOR,r16							; schreibe modeselector in ram
						
						jmp			SPIC_ISR_DEV											; springe

;-Portexpander 1 config verarbeitung----------------------------------------------------------------------------
SPIC_ISR_PX1_CON:		lds			r28,CVAR_SRAM_SPIC_CONFIGBC2							; lade config bytecount 2 in r28
						cpi			r28,0													; wenn bytecount null
						breq		SPIC_ISR_PX1_CON_END									; springe

						lds			r16,CVAR_SRAM_SPIC_CONFIGBC3							; lade config bytecount 3 in r16
						cpi			r16,1													; wenn maxbytecountmerker nicht null
						brsh		SPIC_ISR_PX1_CON_1										; springe

						sts			CVAR_SRAM_SPIC_CONFIGBC3,r28							; lade bytecount in maxbytecountmerker im ram
						mov			r16,r28													; kopiere bytecount in r16

SPIC_ISR_PX1_CON_1:		sub			r16,r28													; subtrahiere bytecount von maxbytecountmerker

						dec			r28														; reduziere bytecount um einen
						sts			CVAR_SRAM_SPIC_CONFIGBC2,r28							; speichere bytecount in ram
						
						ldi			r28,low(CVAR_SRAM_SPIC_CONFIG_START)					; lade erste ram commando adresse in Y
						ldi			r29,high(CVAR_SRAM_SPIC_CONFIG_START)					; "
						add			r28,r16													; addiere subtraktionsergebnis
						clr			r16														; "
						adc			r29,r16													; "

						ld			r16,Y													; lade commandobyte in ram adresse in Y in r16

						sts			SPIC_DATA,r16											; sende commando

						jmp			SPIC_ISR_END											; springe
						
SPIC_ISR_PX1_CON_END:	ldi			r16,0b00001000											; beende bertragungs sequenz
						sts			PORTD_OUTSET,r16										; "

						clr			r16														; lade nullen in r16
						sts			CVAR_SRAM_SPIC_CONFIGBC3,r16							; schreibe nullen in maxbytecountmerker

						lds			r16,CVAR_SRAM_SPIC_MODESELECTOR							; lade modeselector in r16
						andi		r16,0b11111101											; lsche lcd config bit
						sts			CVAR_SRAM_SPIC_MODESELECTOR,r16							; schreibe modeselector in ram
						
						jmp			SPIC_ISR_DEV											; springe

;-Portexpander 2 config verarbeitung----------------------------------------------------------------------------
SPIC_ISR_PX2_CON:		lds			r28,CVAR_SRAM_SPIC_CONFIGBC2							; lade config bytecount 2 in r28
						cpi			r28,0													; wenn bytecount null
						breq		SPIC_ISR_PX2_CON_END									; springe

						lds			r16,CVAR_SRAM_SPIC_CONFIGBC3							; lade config bytecount 3 in r16
						cpi			r16,1													; wenn maxbytecountmerker nicht null
						brsh		SPIC_ISR_PX2_CON_1										; springe

						sts			CVAR_SRAM_SPIC_CONFIGBC3,r28							; lade bytecount in maxbytecountmerker im ram
						mov			r16,r28													; kopiere bytecount in r16

SPIC_ISR_PX2_CON_1:		sub			r16,r28													; subtrahiere bytecount von maxbytecountmerker

						dec			r28														; reduziere bytecount um einen
						sts			CVAR_SRAM_SPIC_CONFIGBC2,r28							; speichere bytecount in ram
						
						ldi			r28,low(CVAR_SRAM_SPIC_CONFIG_START)					; lade erste ram commando adresse in Y
						ldi			r29,high(CVAR_SRAM_SPIC_CONFIG_START)					; "
						add			r28,r16													; addiere subtraktionsergebnis
						clr			r16														; "
						adc			r29,r16													; "

						ld			r16,Y													; lade commandobyte in ram adresse in Y in r16

						sts			SPIC_DATA,r16											; sende commando

						jmp			SPIC_ISR_END											; springe
						
SPIC_ISR_PX2_CON_END:	ldi			r16,0b00010000											; beende bertragungs sequenz
						sts			PORTD_OUTSET,r16										; "

						clr			r16														; lade nullen in r16
						sts			CVAR_SRAM_SPIC_CONFIGBC3,r16							; schreibe nullen in maxbytecountmerker

						lds			r16,CVAR_SRAM_SPIC_MODESELECTOR							; lade modeselector in r16
						andi		r16,0b11111011											; lsche lcd config bit
						sts			CVAR_SRAM_SPIC_MODESELECTOR,r16							; schreibe modeselector in ram
						
						jmp			SPIC_ISR_DEV											; springe

;----------------------------------------------------------------------------------------------------------------