;-reaktionen auf statusvernderungen----------------------------------------------
StatReact:				push		r16
						push		r17

						lds			r16,CVAR_SRAM_MAIN_STATUS_2											; lade statusbyte 2 in r16

						ldi			r17,0b00000001														; lade bitmuster fr pin0 in r17
						sbrc		r16,0																; wenn bugklappe offen
						sts			PORTC_OUTSET,r17													; schalte lcd beleuchtung ein
						sbrs		r16,0																; wenn bugklappe geschlossen
						sts			PORTC_OUTCLR,r17													; schalte lcd beleuchtung aus

						sbrc		r16,5																; wenn programmiermodus aktiv
						jmp			StatReact_SPID_OFF													; springe
						sbrs		r16,5																; wenn programmiermodus inaktiv
						jmp			StatReact_SPID_ON													; springe
					
StatReact_END:			pop			r17
						pop			r16
						ret

;----------------------------------------------------------------------------------
StatReact_SPID_OFF:		lds			r17,SPID_CTRL														; lade SPID controlregister in r17

						sbrs		r17,6																; wenn SPID schon ausgeschaltet ist
						jmp			StatReact_END														; springe

						andi		r17,0b10111111														; deaktiviere SPID
						sts			SPID_CTRL,r17														; speichere SPID controlregister
						
						ldi			r16,0b10100000														; schalte MOSI und CLK auf eingang (floatend)
						sts			PORTD_DIRCLR,r16													; "
						
						jmp			StatReact_END

;----------------------------------------------------------------------------------
StatReact_SPID_ON:		lds			r17,SPID_CTRL														; lade SPID controlregister in r17
						
						sbrc		r17,6																; wenn SPID schon eingeschaltet ist
						jmp			StatReact_END														; springe

						ldi			r16,0b10100000														; schalte MOSI und CLK auf ausgang (driven)
						sts			PORTD_DIRSET,r16													; "
						
						ori			r17,0b01000000														; aktiviere SPID
						sts			SPID_CTRL,r17														; speichere SPID controlregister
						
						jmp			StatReact_END

;----------------------------------------------------------------------------------
