;-Einstellung des Systemtaktes-------------------------------------------------------------------------
SysClkConf:		push	r16
				in		r16,CPU_SREG
				push	r16
				push	r17
				push	r30
				push	r31
				
				ldi		r16,0xD8													; lade Bitmuster zum ndern von IO Register

				ldi		r17,0b11001011												; Setze Oscillator auf 16MHz Cristal mit 16k StartUp
				out		CPU_CCP,r16													; schreibe nder-Bitmuster in CCP
				sts		OSC_XOSCCTRL,r17											; "

				lds		r17,OSC_CTRL												; lade oscillator control register
				ori		r17,0b00001000												; setze bit fr enable externe taktquelle
				out		CPU_CCP,r16													; schreibe nder-Bitmuster in CCP
				sts		OSC_CTRL,r17												; schreibe bitmuster

				clr		r30															; initialisiere wartezhler mit 0
				clr		r31															; "
SysClkConf1:	adiw	r30,1														; erhhe wartezhler um einen
				cpi		r31,255														; wenn wartezhler 65280 erreicht
				breq	SysClkConf3													; springe
				lds		r17,OSC_STATUS												; Lade Systemtakt Status in r17
				sbrs	r17,3														; solange PLL nicht stabil
				jmp		SysClkConf1													; springe

				ldi		r17,0b11000000												; setze PLL Taktquelle auf extern und 
				ori		r17,CVAR_CPU_FACTOR											; setze Faktor
				out		CPU_CCP,r16													; schreibe nder-Bitmuster in CCP
				sts		OSC_PLLCTRL,r17												; "

				lds		r17,OSC_CTRL												; lade oscillator control register
				ori		r17,0b00010000												; setze bit fr enable PLL
				out		CPU_CCP,r16													; schreibe nder-Bitmuster in CCP
				sts		OSC_CTRL,r17												; schreibe bitmuster
				
				clr		r30															; initialisiere wartezhler mit 0
				clr		r31															; "
SysClkConf2:	adiw	r30,1														; erhhe wartezhler um einen
				cpi		r31,255														; wenn wartezhler 65280 erreicht
				breq	SysClkConf3													; springe
				lds		r17,OSC_STATUS												; Lade Systemtakt Status in r17
				sbrs	r17,4														; solange PLL nicht stabil
				jmp		SysClkConf2													; springe

				ldi		r17,CVAR_CPU_DividerA										; Stelle Prescaler A, B und C ein
				lsl		r17															; "
				lsl		r17															; "
				ori		r17,CVAR_CPU_DividerBC										; "
				out		CPU_CCP,r16													; schreibe nder-Bitmuster in CCP
				sts		CLK_PSCTRL,r17												; "

				ldi		r17,0b00000100												; lade Bitmuster fr Systemtaktquelle auf PLL
				out		CPU_CCP,r16													; schreibe nder-Bitmuster in CCP
				sts		CLK_CTRL,r17												; setze systemtakt auf pll

				lds		r17,OSC_CTRL												; lade oscillator control register
				andi	r17,0b00011000												; deaktiviere alle nicht bentigten Taktquellen
				out		CPU_CCP,r16													; schreibe nder-Bitmuster in CCP
				sts		OSC_CTRL,r17												; schreibe bitmuster

				lds		r17,CVAR_SRAM_MAIN_STATUS_1									; lsche "clock instable bit" im ram: statusregister 1 bit 0
				andi	r17,0b11111110												; "
				sts		CVAR_SRAM_MAIN_STATUS_1,r17									; "

				ldi		r17,0b00000011												; lade bitmaske fr: lsche OSC Interrupt Flag und enable OSC Interrupt
				out		CPU_CCP,r16													; schreibe nder-Bitmuster in CCP
				sts		OSC_XOSCFAIL,r17											; schreibe bitmuster

SysClkConf4:	pop		r31
				pop		r30
				pop		r17
				pop		r16
				out		CPU_SREG,r16
				pop		r16
				ret
;---------------------------------------------------------------------------------------
SysClkConf3:	lds		r17,CVAR_SRAM_MAIN_STATUS_1									; setze "clock instable bit" im ram: statusregister 1 bit 0
				ori		r17,0b00000001												; "
				sts		CVAR_SRAM_MAIN_STATUS_1,r17									; "
				jmp		SysClkConf4													; rcksprung
;---------------------------------------------------------------------------------------