;%%% User Definitionen %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;################################################################################################################
; Steuergren 
;################################################################################################################
.equ		CVAR_CPU_Factor=						4																; 16MHz PLL Multiplikator 1-31 [Systemtakt = 64MHz]
.equ		CVAR_CPU_DividerA=						0																; Systemtakt Divider A (0 fr A=1)
.equ		CVAR_CPU_DividerBC=						1																; Systemtakt Divider B und C (1 fr B=1 und C=2) [CPU Takt = 32MHz]

.equ		CVAR_SPIC_Pre=							2																; SPIC Vorteiler: (2 = 64) [SPIC Takt = 500kHz]

.equ		CVAR_SPID_Pre=							0																; SPID Vorteiler: (0 = 4) [SPID Takt = 8MHz]

.equ		CVAR_ADCA_Pre=							6																; ADCA Vorteiler: (6 = 256) [ADC Takt = 125kHz]
.equ		CVAR_ADCA_Offset=						100																; ADCA Offset: (100 = 0,05V)
.equ		CVAR_ADCA_BSIZE=						24																; ADCA Blockgre: Anzahl der Ergebnisbytes fr DMA

.equ		CVAR_TCC0_Pre=							7																; Timer/Counter C0 Vorteiler: (7 = 1024) [TCC0 Takt = 31,25kHz]
.equ		CVAR_TCC0_Per=							3906															; Timer/Counter C0 Periodendauer: maximaler zhlerwert
.equ		CVAR_TCC0_CpA=							1953															; Timer/Counter C0 Compare A: 1953 = 16Hz
.equ		CVAR_TCC0_CpB=							3906															; Timer/Counter C0 Compare B: 3906 = 8Hz
.equ		CVAR_TCC0_CpC=							0																; Timer/Counter C0 Compare C: reserved
.equ		CVAR_TCC0_CpD=							0																; Timer/Counter C0 Compare D: reserved

.equ		CVAR_TCC1_Pre=							7																; Timer/Counter C1 Vorteiler: (7 = 1024) [TCC1 Takt = 31,25kHz]
.equ		CVAR_TCC1_Per=							0																; Timer/Counter C1 Periodendauer: Reserved
.equ		CVAR_TCC1_CpA=							14																; Timer/Counter C1 Compare A: CCA = (f_per / (2 * pre * f)) - 1, [14 = 1kHz]
.equ		CVAR_TCC1_CpB=							0																; Timer/Counter C1 Compare B: reserved

.equ		CVAR_TCD1_Pre=							1																; Timer/Counter D1 Vorteiler: (1 = 1) [TCD1 Takt = 32MHz]
.equ		CVAR_TCD1_Per=							79																; Timer/Counter D1 Periodendauer: 19 (Drehgeber rastungen*4 pro umdrehung - 1)
.equ		CVAR_TCD1_CpA=							0																; Timer/Counter D1 Compare A: reserved
.equ		CVAR_TCD1_CpB=							0																; Timer/Counter D1 Compare B: reserved

.equ		CVAR_USARTE0_SEL_Init=					12																; USART E0 Selector: Initialisierung (Sel=12, Frc=4 => 9600 Baud)
.equ		CVAR_USARTE0_FRC_Init=					4																; USART E0 Fractional: Initialisierung
.equ		CVAR_USARTE0_SEL_Full=					1																; USART E0 Selector: Normalbetrieb (Sel=1, Frc=-4 => 115200 Baud)
.equ		CVAR_USARTE0_FRC_Full=					-4																; USART E0 Fractional: Normalbetrieb

.equ		CVAR_EEPROM_PAGESIZE=					32																; Eeprom Page Size

;################################################################################################################
; RAM Einteilung
;################################################################################################################
; LCD Schattenram
.equ		CVAR_SRAM_LCD_SHADOWRAM_START=			INTERNAL_SRAM_START												; start des LCD schattenrams
.equ		CVAR_SRAM_LCD_SHADOWRAM_SIZE=			0x0400															; gre des LCD schattenrams
.equ		CVAR_SRAM_LCD_SHADOWRAM_END=			(INTERNAL_SRAM_START + 0x0400 - 1)								; ende des LCD schattenrams

; Block-Startadressen
.equ		CVAR_SRAM_SPI_START=					(CVAR_SRAM_LCD_SHADOWRAM_START + CVAR_SRAM_LCD_SHADOWRAM_SIZE)	; anfang des SPI steuerbreiches
.equ		CVAR_SRAM_ADC_START=					(CVAR_SRAM_SPI_START + 36)										; anfang des ADC Bereiches
.equ		CVAR_SRAM_MAINSYS_START=				(CVAR_SRAM_ADC_START + 73)										; anfang des allgemeinen steuerbereiches
.equ		CVAR_SRAM_REMOTECON_START=				(CVAR_SRAM_MAINSYS_START + 7)									; anfang des Remote Control Variablen Bereiches

; PortExpander IO
.equ		CVAR_SRAM_PORTX1_OUTPUT=				(CVAR_SRAM_SPI_START + 0)										; Portexpander 1 Outputs
.equ		CVAR_SRAM_PORTX1_INPUT=					(CVAR_SRAM_SPI_START + 1)										; Portexpander 1 Inputs
.equ		CVAR_SRAM_PORTX1_DIR=					(CVAR_SRAM_SPI_START + 2)										; Portexpander 1 Directory
.equ		CVAR_SRAM_PORTX2_OUTPUT=				(CVAR_SRAM_SPI_START + 3)										; Portexpander 2 Outputs
.equ		CVAR_SRAM_PORTX2_INPUT=					(CVAR_SRAM_SPI_START + 4)										; Portexpander 2 Inputs
.equ		CVAR_SRAM_PORTX2_DIR=					(CVAR_SRAM_SPI_START + 5)										; Portexpander 2 Directory

; SPIC Slave Controlling
.equ		CVAR_SRAM_SPIC_SLAVESELECTOR=			(CVAR_SRAM_SPI_START + 6)										; SPIC Slaveselector bit0=LCD, bit1=PortEx1, bit2=PortEx2
.equ		CVAR_SRAM_SPIC_MODESELECTOR=			(CVAR_SRAM_SPI_START + 7)										; SPIC Modeselector bit0: Config LCD, bit1: Config PortEx1, bit2: Config PortEx2
.equ		CVAR_SRAM_SPIC_DATABC_LOW=				(CVAR_SRAM_SPI_START + 8)										; SPIC Daten Bytezhler Low
.equ		CVAR_SRAM_SPIC_DATABC_HIGH=				(CVAR_SRAM_SPI_START + 9)										; SPIC Daten Bytezhler High
.equ		CVAR_SRAM_SPIC_CONFIGBC1=				(CVAR_SRAM_SPI_START + 10)										; SPIC Bytecount1 fr Anzahl der Configurations Bytes
.equ		CVAR_SRAM_SPIC_CONFIGBC2=				(CVAR_SRAM_SPI_START + 11)										; SPIC Bytecount2 fr Anzahl der Configurations Bytes (configurer set)
.equ		CVAR_SRAM_SPIC_CONFIGBC3=				(CVAR_SRAM_SPI_START + 12)										; SPIC Bytecount3 fr Anzahl der Configurations Bytes
.equ		CVAR_SRAM_SPIC_PX_READ_START=			(CVAR_SRAM_SPI_START + 13)										; 7 bytes fr lese/schreibe sequenz der portexpander (system set)
.equ		CVAR_SRAM_SPIC_CONFIG_START=			(CVAR_SRAM_SPI_START + 20)										; SPIC start der konfigurationsbytes (1- 16) (configurer set)

; SPID Slave Controlling


; ADC Bereich rohwerte
.equ		CVAR_SRAM_ADC_RAW_I_ENGINE_LOW=			(CVAR_SRAM_ADC_START + 0)										; Pin 0 Rohwert: Strom fr Engine/Supply
.equ		CVAR_SRAM_ADC_RAW_I_ENGINE_HIGH=		(CVAR_SRAM_ADC_START + 1)										; "
.equ		CVAR_SRAM_ADC_RAW_I_SLAVE_A1_LOW=		(CVAR_SRAM_ADC_START + 2)										; Pin 1 Rohwert: Strom fr Slave A1 logik
.equ		CVAR_SRAM_ADC_RAW_I_SLAVE_A1_HIGH=		(CVAR_SRAM_ADC_START + 3)										; "
.equ		CVAR_SRAM_ADC_RAW_I_SLAVE_A2_LOW=		(CVAR_SRAM_ADC_START + 4)										; Pin 2 Rohwert: Strom fr Slave A2 logik
.equ		CVAR_SRAM_ADC_RAW_I_SLAVE_A2_HIGH=		(CVAR_SRAM_ADC_START + 5)										; "
.equ		CVAR_SRAM_ADC_RAW_I_SLAVE_A3_LOW=		(CVAR_SRAM_ADC_START + 6)										; Pin 3 Rohwert: Strom fr Slave A3 logik
.equ		CVAR_SRAM_ADC_RAW_I_SLAVE_A3_HIGH=		(CVAR_SRAM_ADC_START + 7)										; "
.equ		CVAR_SRAM_ADC_RAW_I_SLAVE_A4_LOW=		(CVAR_SRAM_ADC_START + 8)										; Pin 4 Rohwert: Strom fr Slave A4 logik
.equ		CVAR_SRAM_ADC_RAW_I_SLAVE_A4_HIGH=		(CVAR_SRAM_ADC_START + 9)										; "
.equ		CVAR_SRAM_ADC_RAW_I_SLAVE_A5_LOW=		(CVAR_SRAM_ADC_START + 10)										; Pin 5 Rohwert: Strom fr Slave A5 logik
.equ		CVAR_SRAM_ADC_RAW_I_SLAVE_A5_HIGH=		(CVAR_SRAM_ADC_START + 11)										; "
.equ		CVAR_SRAM_ADC_RAW_I_SLAVE_B1_LOW=		(CVAR_SRAM_ADC_START + 12)										; Pin 6 Rohwert: Strom fr Slave B1 logik
.equ		CVAR_SRAM_ADC_RAW_I_SLAVE_B1_HIGH=		(CVAR_SRAM_ADC_START + 13)										; "
.equ		CVAR_SRAM_ADC_RAW_I_SLAVE_B2_LOW=		(CVAR_SRAM_ADC_START + 14)										; Pin 7 Rohwert: Strom fr Slave B2 logik
.equ		CVAR_SRAM_ADC_RAW_I_SLAVE_B2_HIGH=		(CVAR_SRAM_ADC_START + 15)										; "
.equ		CVAR_SRAM_ADC_RAW_I_CPU_LOW=			(CVAR_SRAM_ADC_START + 16)										; Pin 8 Rohwert: Strom fr Mainboard
.equ		CVAR_SRAM_ADC_RAW_I_CPU_HIGH=			(CVAR_SRAM_ADC_START + 17)										; "
.equ		CVAR_SRAM_ADC_RAW_U_ACCU_LOW=			(CVAR_SRAM_ADC_START + 18)										; Pin 9 Rohwert: Akku-Spannung
.equ		CVAR_SRAM_ADC_RAW_U_ACCU_HIGH=			(CVAR_SRAM_ADC_START + 19)										; "
.equ		CVAR_SRAM_ADC_RAW_CH10_LOW=				(CVAR_SRAM_ADC_START + 20)										; Pin 10 Rohwert: Reserved
.equ		CVAR_SRAM_ADC_RAW_CH10_HIGH=			(CVAR_SRAM_ADC_START + 21)										; "
.equ		CVAR_SRAM_ADC_RAW_CH11_LOW=				(CVAR_SRAM_ADC_START + 22)										; Pin 11 Rohwert: Reserved
.equ		CVAR_SRAM_ADC_RAW_CH11_HIGH=			(CVAR_SRAM_ADC_START + 23)										; "

; ADC Bereich arithmetik speicher
.equ		CVAR_SRAM_ADC_AMM_I_ENGINE_LOW=			(CVAR_SRAM_ADC_START + 24)										; Pin 0: arithmetische mittel-rohwert aufaddition
.equ		CVAR_SRAM_ADC_AMM_I_ENGINE_HIGH=		(CVAR_SRAM_ADC_START + 25)										; "
.equ		CVAR_SRAM_ADC_AMM_I_SLAVE_A1_LOW=		(CVAR_SRAM_ADC_START + 26)										; Pin 1: arithmetische mittel-rohwert aufaddition
.equ		CVAR_SRAM_ADC_AMM_I_SLAVE_A1_HIGH=		(CVAR_SRAM_ADC_START + 27)										; "
.equ		CVAR_SRAM_ADC_AMM_I_SLAVE_A2_LOW=		(CVAR_SRAM_ADC_START + 28)										; Pin 2: arithmetische mittel-rohwert aufaddition
.equ		CVAR_SRAM_ADC_AMM_I_SLAVE_A2_HIGH=		(CVAR_SRAM_ADC_START + 29)										; "
.equ		CVAR_SRAM_ADC_AMM_I_SLAVE_A3_LOW=		(CVAR_SRAM_ADC_START + 30)										; Pin 3: arithmetische mittel-rohwert aufaddition
.equ		CVAR_SRAM_ADC_AMM_I_SLAVE_A3_HIGH=		(CVAR_SRAM_ADC_START + 31)										; "
.equ		CVAR_SRAM_ADC_AMM_I_SLAVE_A4_LOW=		(CVAR_SRAM_ADC_START + 32)										; Pin 4: arithmetische mittel-rohwert aufaddition
.equ		CVAR_SRAM_ADC_AMM_I_SLAVE_A4_HIGH=		(CVAR_SRAM_ADC_START + 33)										; "
.equ		CVAR_SRAM_ADC_AMM_I_SLAVE_A5_LOW=		(CVAR_SRAM_ADC_START + 34)										; Pin 5: arithmetische mittel-rohwert aufaddition
.equ		CVAR_SRAM_ADC_AMM_I_SLAVE_A5_HIGH=		(CVAR_SRAM_ADC_START + 35)										; "
.equ		CVAR_SRAM_ADC_AMM_I_SLAVE_B1_LOW=		(CVAR_SRAM_ADC_START + 36)										; Pin 6: arithmetische mittel-rohwert aufaddition
.equ		CVAR_SRAM_ADC_AMM_I_SLAVE_B1_HIGH=		(CVAR_SRAM_ADC_START + 37)										; "
.equ		CVAR_SRAM_ADC_AMM_I_SLAVE_B2_LOW=		(CVAR_SRAM_ADC_START + 38)										; Pin 7: arithmetische mittel-rohwert aufaddition
.equ		CVAR_SRAM_ADC_AMM_I_SLAVE_B2_HIGH=		(CVAR_SRAM_ADC_START + 39)										; "
.equ		CVAR_SRAM_ADC_AMM_I_CPU_LOW=			(CVAR_SRAM_ADC_START + 40)										; Pin 8: arithmetische mittel-rohwert aufaddition
.equ		CVAR_SRAM_ADC_AMM_I_CPU_HIGH=			(CVAR_SRAM_ADC_START + 41)										; "
.equ		CVAR_SRAM_ADC_AMM_U_ACCU_LOW=			(CVAR_SRAM_ADC_START + 42)										; Pin 9: arithmetische mittel-rohwert aufaddition
.equ		CVAR_SRAM_ADC_AMM_U_ACCU_HIGH=			(CVAR_SRAM_ADC_START + 43)										; "
.equ		CVAR_SRAM_ADC_AMM_CH10_LOW=				(CVAR_SRAM_ADC_START + 44)										; Pin 10: reserved
.equ		CVAR_SRAM_ADC_AMM_CH10_HIGH=			(CVAR_SRAM_ADC_START + 45)										; "
.equ		CVAR_SRAM_ADC_AMM_CH11_LOW=				(CVAR_SRAM_ADC_START + 46)										; Pin 11: reserved
.equ		CVAR_SRAM_ADC_AMM_CH11_HIGH=			(CVAR_SRAM_ADC_START + 47)										; "

; ADC Bereich berechnete werte
.equ		CVAR_SRAM_ADC_I_ENGINE_LOW=				(CVAR_SRAM_ADC_START + 48)										; Pin 0: Stromwert fr Engine/Supply berechnet auf 1mA/bit
.equ		CVAR_SRAM_ADC_I_ENGINE_HIGH=			(CVAR_SRAM_ADC_START + 49)										; "
.equ		CVAR_SRAM_ADC_I_SLAVE_A1_LOW=			(CVAR_SRAM_ADC_START + 50)										; Pin 1: Stromwert fr Slave A1 logik berechnet auf 1mA/bit
.equ		CVAR_SRAM_ADC_I_SLAVE_A1_HIGH=			(CVAR_SRAM_ADC_START + 51)										; "
.equ		CVAR_SRAM_ADC_I_SLAVE_A2_LOW=			(CVAR_SRAM_ADC_START + 52)										; Pin 2: Stromwert fr Slave A2 logik berechnet auf 1mA/bit
.equ		CVAR_SRAM_ADC_I_SLAVE_A2_HIGH=			(CVAR_SRAM_ADC_START + 53)										; "
.equ		CVAR_SRAM_ADC_I_SLAVE_A3_LOW=			(CVAR_SRAM_ADC_START + 54)										; Pin 3: Stromwert fr Slave A3 logik berechnet auf 1mA/bit
.equ		CVAR_SRAM_ADC_I_SLAVE_A3_HIGH=			(CVAR_SRAM_ADC_START + 55)										; "
.equ		CVAR_SRAM_ADC_I_SLAVE_A4_LOW=			(CVAR_SRAM_ADC_START + 56)										; Pin 4: Stromwert fr Slave A4 logik berechnet auf 1mA/bit
.equ		CVAR_SRAM_ADC_I_SLAVE_A4_HIGH=			(CVAR_SRAM_ADC_START + 57)										; "
.equ		CVAR_SRAM_ADC_I_SLAVE_A5_LOW=			(CVAR_SRAM_ADC_START + 58)										; Pin 5: Stromwert fr Slave A5 logik berechnet auf 1mA/bit
.equ		CVAR_SRAM_ADC_I_SLAVE_A5_HIGH=			(CVAR_SRAM_ADC_START + 59)										; "
.equ		CVAR_SRAM_ADC_I_SLAVE_B1_LOW=			(CVAR_SRAM_ADC_START + 60)										; Pin 6: Stromwert fr Slave B1 logik berechnet auf 1mA/bit
.equ		CVAR_SRAM_ADC_I_SLAVE_B1_HIGH=			(CVAR_SRAM_ADC_START + 61)										; "
.equ		CVAR_SRAM_ADC_I_SLAVE_B2_LOW=			(CVAR_SRAM_ADC_START + 62)										; Pin 7: Stromwert fr Slave B2 logik berechnet auf 1mA/bit
.equ		CVAR_SRAM_ADC_I_SLAVE_B2_HIGH=			(CVAR_SRAM_ADC_START + 63)										; "
.equ		CVAR_SRAM_ADC_I_CPU_LOW=				(CVAR_SRAM_ADC_START + 64)										; Pin 8: Stromwert fr Mainboard berechnet auf 1mA/bit
.equ		CVAR_SRAM_ADC_I_CPU_HIGH=				(CVAR_SRAM_ADC_START + 65)										; "
.equ		CVAR_SRAM_ADC_U_ACCU_LOW=				(CVAR_SRAM_ADC_START + 66)										; Pin 9: Spannungswert des Akkumulator berechnet auf 10mV/bit
.equ		CVAR_SRAM_ADC_U_ACCU_HIGH=				(CVAR_SRAM_ADC_START + 67)										; "
.equ		CVAR_SRAM_ADC_CH10_LOW=					(CVAR_SRAM_ADC_START + 68)										; Pin 10: Reserved
.equ		CVAR_SRAM_ADC_CH10_HIGH=				(CVAR_SRAM_ADC_START + 69)										; "
.equ		CVAR_SRAM_ADC_CH11_LOW=					(CVAR_SRAM_ADC_START + 70)										; Pin 11: Reserved
.equ		CVAR_SRAM_ADC_CH11_HIGH=				(CVAR_SRAM_ADC_START + 71)										; "

.equ		CVAR_SRAM_ADC_AMM_COUNT=				(CVAR_SRAM_ADC_START + 72)										; zhler fr mittelwert berechnung

; Genral Propose Controlling
.equ		CVAR_SRAM_MAIN_STATUS_1=				(CVAR_SRAM_MAINSYS_START + 0)									; Statusregister1: 0: Clock Instable Flag, 1: WLAN Modul fehlt, 2: StartUp, 3:interne initialisierung ok
																													;					4: normal operating flag, 5: submodul fehler flag, 6: Command received flag, 7: 
.equ		CVAR_SRAM_MAIN_STATUS_2=				(CVAR_SRAM_MAINSYS_START + 1)									; Statusregister2:	0: Bugklappe offen, 1: Beleuchtung eingeschaltet, 2: Warfare Modus, 3: Anti Kollision Modus
																													;					4: Power Down Modus, 5: Programmier Modus, 6: Automatikmodus, 7: WLAN Engine Lock
.equ		CVAR_SRAM_MAIN_STATUS_3=				(CVAR_SRAM_MAINSYS_START + 2)									; Statusregister3:	0: Akku leer Flag, 1: Akku niedrig Flag, 2: , 3: 
																													;					4: , 5: , 6: , 7: 
.equ		CVAR_SRAM_MAIN_PEEP_CON=				(CVAR_SRAM_MAINSYS_START + 3)									; peeper kontrollwert
.equ		CVAR_SRAM_MAIN_PEEP_CNT=				(CVAR_SRAM_MAINSYS_START + 4)									; peeper cycle counter
.equ		CVAR_SRAM_MAIN_BLINK_CNT1=				(CVAR_SRAM_MAINSYS_START + 5)									; prozess-led kontrollwert
.equ		CVAR_SRAM_MAIN_BLINK_CNT2=				(CVAR_SRAM_MAINSYS_START + 6)									; prozess-led cycle counter
.equ		CVAR_SRAM_MAIN_SUBMODPOWER=				(CVAR_SRAM_MAINSYS_START + 7)									; Steuerregister fr Energieversorgung der Submodule
																													; 0: B2, 1: B1, 2: A5, 3: A4, 4: A3, 5: A2, 6: A1, 7: Engine
.equ		CVAR_SRAM_MAIN_SUBMODRECOG=				(CVAR_SRAM_MAINSYS_START + 8)									; Speicher fr erkannte Module
																													; 0: B2, 1: B1, 2: A5, 3: A4, 4: A3, 5: A2, 6: A1 7: Reserved

; Remote Control Variablen
.equ		CVAR_SRAM_RCON_ACCUEMPTY_LOW=			(CVAR_SRAM_REMOTECON_START + 0)									; Grenzwert fr Akku leer low
.equ		CVAR_SRAM_RCON_ACCUEMPTY_HIGH=			(CVAR_SRAM_REMOTECON_START + 1)									; Grenzwert fr Akku leer high
.equ		CVAR_SRAM_RCON_ACCULOW_LOW=				(CVAR_SRAM_REMOTECON_START + 2)									; Grenzwert fr Akku niedrig low
.equ		CVAR_SRAM_RCON_ACCULOW_HIGH=			(CVAR_SRAM_REMOTECON_START + 3)									; Grenzwert fr Akku niedrig high